unit uDM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, kbmMemTable;

type
  TDM = class(TDataModule)
    dsCustomer: TDataSource;
    dsProduct: TDataSource;
    dsCommand: TDataSource;
    dsCommandLigne: TDataSource;
    tbCustomer: TkbmMemTable;
    tbProduct: TkbmMemTable;
    tbCommand: TkbmMemTable;
    tbCommandLigne: TkbmMemTable;
    tbCustomerIDCustomer: TAutoIncField;
    tbCustomerLastName: TStringField;
    tbCustomerFirstName: TStringField;
    tbCustomerCompany: TStringField;
    tbCustomerStatus: TStringField;
    tbCustomerEmail: TStringField;
    tbCustomerAddress1: TStringField;
    tbCustomerAddress2: TStringField;
    tbCustomerCity: TStringField;
    tbCustomerState: TStringField;
    tbCustomerZip: TStringField;
    tbCustomerCountry: TStringField;
    tbCustomerPhone: TStringField;
    tbCustomerFax: TStringField;
    tbCustomerComments: TStringField;
    tbProductIDProduct: TAutoIncField;
    tbProductProdName: TStringField;
    tbProductProdCategory: TStringField;
    tbProductProdPrice: TCurrencyField;
    tbCommandIDCommand: TAutoIncField;
    tbCommandIDCustomer: TIntegerField;
    tbCommandLigneIDlcCommand: TIntegerField;
    tbCommandLigneIDlcComLigne: TAutoIncField;
    tbCommandLigneIDProduct: TIntegerField;
    tbCommandLigneQuantity: TSmallintField;
    tbCommandLignePrice: TCurrencyField;
    tbCommandLigneProductName: TStringField;
    tbLigneByCommand: TkbmMemTable;
    dsLigneByCommand: TDataSource;
    tbCommandCustomerLastName: TStringField;

    procedure DMCreate(Sender: TObject);
    procedure DMDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  DM: TDM;

implementation

uses uConst;


{$R *.DFM}

procedure TDM.DMCreate(Sender: TObject);
var
  io: TIndexOptions;
begin

  tbCustomer.Close;
  tbProduct.Close;
  tbCommand.Close;
  tbCommandLigne.Close;

  tbCustomer.DisableControls;
  tbCustomer.Open;
  tbCustomer.LoadFromBinaryFile(gDBPath + 'Customer.bin');
  tbCustomer.AddIndex('ixIDCustomer', 'IDCustomer', [ixUnique]);
  tbCustomer.AddIndex('ixNomPrenom', 'LastName;FirstName', [ixCaseInsensitive]);
  tbCustomer.IndexName := 'ixIDCustomer';
  tbCustomer.EnableControls;

  tbProduct.DisableControls;
  tbProduct.Open;
  tbProduct.LoadFromBinaryFile(gDBPath + 'Product.bin');
  tbProduct.AddIndex('ixIDProduct', 'IDProduct', [ixUnique]);
  tbProduct.IndexName := 'ixIDProduct';
  tbProduct.EnableControls;

  tbCommand.DisableControls;
  tbCommand.Open;
  tbCommand.LoadFromBinaryFile(gDBPath + 'Command.bin');
  tbCommand.AddIndex('ixIDCommand', 'IDCommand', [ixUnique]);
  tbCommand.AddIndex('ixIDCustomer', 'IDCustomer', []);
  tbCommand.IndexName := 'ixIDCommand';
  tbCommand.EnableControls;

  tbCommandLigne.DisableControls;
  tbCommandLigne.Open;
  tbCommandLigne.LoadFromBinaryFile(gDBPath + 'CommandLigne.bin');
  tbCommandLigne.AddIndex('ixIDCommandLigne', 'IDlcCommand;IDlcComLigne', []);
  tbCommandLigne.IndexName := 'ixIDCommandLigne';
  tbCommandLigne.EnableControls;
end;

procedure TDM.DMDestroy(Sender: TObject);
begin
  tbCustomer.SaveToBinaryFile(gDBPath + 'Customer.bin', kbmSaveAllData);
  tbProduct.SaveToBinaryFile(gDBPath + 'Product.bin', kbmSaveAllData);
  tbCommand.SaveToBinaryFile(gDBPath + 'Command.bin', kbmSaveAllData);
  tbCommandLigne.SaveToBinaryFile(gDBPath + 'CommandLigne.bin', kbmSaveAllData);
end;

end.

